﻿Imports System.Runtime.InteropServices

Module FA_DLL

    <DllImport("FASlave.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function FA_ComOpen(ByVal Port As Byte) As Byte
    End Function

    <DllImport("FASlave.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function FA_ComClose(ByVal Port As Byte) As Byte
    End Function

    <DllImport("FASlave.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function FA_LEDWrite(ByVal Port As Byte, ByVal Value As Integer) As Byte
    End Function

    <DllImport("FASlave.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function FA_LEDOn(ByVal Port As Byte, ByVal Index As Integer) As Byte
    End Function

    <DllImport("FASlave.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function FA_LEDOff(ByVal Port As Byte, ByVal Index As Integer) As Byte
    End Function

    <DllImport("FASlave.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function FA_ReadSwitch(ByVal Port As Byte, ByVal Index As Integer) As Byte
    End Function

    <DllImport("FASlave.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function FA_SetMotors(ByVal Port As Byte, ByVal Left As Integer, ByVal Right As Integer) As Byte
    End Function

    <DllImport("FASlave.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function FA_ReadIR(ByVal Port As Byte, ByVal Index As Integer) As Integer
    End Function

    <DllImport("FASlave.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function FA_ReadLine(ByVal Port As Byte, ByVal Index As Integer) As Integer
    End Function

    <DllImport("FASlave.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function FA_ReadLight(ByVal Port As Byte) As Integer
    End Function

    <DllImport("FASlave.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function FA_Forwards(ByVal Port As Byte, ByVal Distance As Integer) As Byte
    End Function

    <DllImport("FASlave.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function FA_Backwards(ByVal Port As Byte, ByVal Distance As Integer) As Byte
    End Function

    <DllImport("FASlave.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function FA_Left(ByVal Port As Byte, ByVal Angle As Integer) As Byte
    End Function

    <DllImport("FASlave.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function FA_Right(ByVal Port As Byte, ByVal Angle As Integer) As Byte
    End Function

    <DllImport("FASlave.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function FA_SetLogoSpeed(ByVal Port As Byte, ByVal Speed As Integer) As Byte
    End Function

    <DllImport("FASlave.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function FA_EncoderReset(ByVal Port As Byte) As Byte
    End Function

    <DllImport("FASlave.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function FA_EncoderRead(ByVal Port As Byte, ByVal Index As Integer) As Integer
    End Function

    <DllImport("FASlave.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function FA_LCDClear(ByVal Port As Byte) As Byte
    End Function

    <DllImport("FASlave.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function FA_LCDPrintString(ByVal Port As Byte, ByVal X As Integer, ByVal Y As Integer, ByVal Text As Byte()) As Byte
    End Function

    <DllImport("FASlave.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function FA_LCDPrintNumber(ByVal Port As Byte, ByVal X As Integer, ByVal Y As Integer, ByVal Num As Integer) As Byte
    End Function

    <DllImport("FASlave.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function FA_LCDDrawPixel(ByVal Port As Byte, ByVal X As Integer, ByVal Y As Integer, ByVal State As Integer) As Byte
    End Function

    <DllImport("FASlave.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function FA_LCDDrawLine(ByVal Port As Byte, ByVal X1 As Integer, ByVal Y1 As Integer, ByVal X2 As Integer, ByVal Y2 As Integer) As Byte
    End Function

    <DllImport("FASlave.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function FA_LCDDrawRect(ByVal Port As Byte, ByVal X1 As Integer, ByVal Y1 As Integer, ByVal X2 As Integer, ByVal Y2 As Integer) As Byte
    End Function

    <DllImport("FASlave.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function FA_LCDBacklight(ByVal Port As Byte, ByVal Value As Integer) As Byte
    End Function

    <DllImport("FASlave.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function FA_LCDVerbose(ByVal Port As Byte, ByVal Value As Integer) As Byte
    End Function

    <DllImport("FASlave.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function FA_ReadMic(ByVal Port As Byte) As Integer
    End Function

    <DllImport("FASlave.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function FA_PlayNote(ByVal Port As Byte, ByVal Note As Integer, ByVal Time As Integer) As Byte
    End Function

    <DllImport("FASlave.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function FA_GetAPIVersion(ByVal Port As Byte) As Integer
    End Function



    <DllImport("FASlave.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function FA_ServoEnable(ByVal Port As Byte, ByVal Index As Integer) As Byte
    End Function

    <DllImport("FASlave.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function FA_ServoDisable(ByVal Port As Byte, ByVal Index As Integer) As Byte
    End Function

    <DllImport("FASlave.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function FA_ServoSetPosition(ByVal Port As Byte, ByVal Index As Integer, ByVal Position As Integer) As Byte
    End Function

    <DllImport("FASlave.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function FA_ServoAutoMoveToPosition(ByVal Port As Byte, ByVal Index As Integer, ByVal Position As Integer) As Byte
    End Function

    <DllImport("FASlave.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function FA_ServoSetAutoMoveSpeed(ByVal Port As Byte, ByVal Speed As Integer) As Byte
    End Function



    <DllImport("FASlave.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function FA_CardInit(ByVal Port As Byte) As Byte
    End Function

    <DllImport("FASlave.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function FA_CardCreate(ByVal Port As Byte, ByVal Text As Byte()) As Byte
    End Function

    <DllImport("FASlave.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function FA_CardOpen(ByVal Port As Byte, ByVal Text As Byte()) As Byte
    End Function

    <DllImport("FASlave.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function FA_CardDelete(ByVal Port As Byte, ByVal Text As Byte()) As Byte
    End Function

    <DllImport("FASlave.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function FA_CardWriteByte(ByVal Port As Byte, ByVal Data As Byte) As Byte
    End Function

    <DllImport("FASlave.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function FA_CardReadByte(ByVal Port As Byte) As Byte
    End Function

    <DllImport("FASlave.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function FA_CardRecordMic(ByVal Port As Byte, ByVal BitDepth As Integer, ByVal SampleRate As Integer, ByVal Time As Integer, ByVal Text As Byte()) As Byte
    End Function

    <DllImport("FASlave.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function FA_CardPlayback(ByVal Port As Byte, ByVal Text As Byte()) As Byte
    End Function

    <DllImport("FASlave.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function FA_CardBitmap(ByVal Port As Byte, ByVal X As Integer, ByVal Y As Integer, ByVal Text As Byte()) As Byte
    End Function



    <DllImport("FASlave.dll", SetLastError:=True, CharSet:=CharSet.Auto)>
    Public Function FA_ReadAxis(ByVal Port As Byte, ByVal Index As Integer) As Integer
    End Function



    'String Conversion macros

    Public Function FA_LCDPrintString(ByVal Port As Byte, ByVal X As Integer, ByVal Y As Integer, ByRef Text As String) As Byte
        FA_LCDPrintString(Port, X, Y, System.Text.Encoding.UTF8.GetBytes(Text))
    End Function

    Public Function FA_CardCreate(ByVal Port As Byte, ByRef Filename As String) As Byte
        Return FA_CardCreate(Port, System.Text.Encoding.UTF8.GetBytes(Filename))
    End Function

    Public Function FA_CardOpen(ByVal Port As Byte, ByRef Filename As String) As Byte
        Return FA_CardOpen(Port, System.Text.Encoding.UTF8.GetBytes(Filename))
    End Function

    Public Function FA_CardDelete(ByVal Port As Byte, ByRef Filename As String) As Byte
        Return FA_CardDelete(Port, System.Text.Encoding.UTF8.GetBytes(Filename))
    End Function

    Public Function FA_CardRecordMic(ByVal Port As Byte, ByVal BitDepth As Integer, ByVal SampleRate As Integer, ByVal Time As Integer, ByRef Filename As String) As Byte
        Return FA_CardRecordMic(Port, BitDepth, SampleRate, Time, System.Text.Encoding.UTF8.GetBytes(Filename))
    End Function

    Public Function FA_CardPlayback(ByVal Port As Byte, ByRef Filename As String) As Byte
        Return FA_CardPlayback(Port, System.Text.Encoding.UTF8.GetBytes(Filename))
    End Function

    Public Function FA_CardBitmap(ByVal Port As Byte, ByVal X As Integer, ByVal Y As Integer, ByRef Filename As String) As Byte
        Return FA_CardBitmap(Port, X, Y, System.Text.Encoding.UTF8.GetBytes(Filename))
    End Function



End Module
